from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle, strEnum

from gso.products.product_blocks.device import DeviceBlock, DeviceBlockInactive, DeviceBlockProvisioning


class DeviceType(strEnum):
    """Enumerator for different device types.

    A device can either be a router or a switch.
    """

    router = "router"
    switch = "switch"


class DeviceInactive(SubscriptionModel, is_base=True):
    device_type: DeviceType
    device: DeviceBlockInactive


class DeviceProvisioning(DeviceInactive, lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    device_type: DeviceType
    device: DeviceBlockProvisioning


class Device(DeviceProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    device_type: DeviceType
    device: DeviceBlock
